// TPMutator.uc -- Teleporter Mutator 
// By 'De Zeurkous', Tue Oct 16 01:28:02 UTC 2007

// Not officially released yet -- still full of crap.
// Dijkstra would not have liked this.

//=============================================================================
// TPMutator -- mutates teleporter URLs.
//=============================================================================
class TPMutator extends Mutator transient config(TPMutator);
      // Should extend LevelMutator; however, MetaMutator still pending
      // conversion to UMeta. 

// version 14 

// Credits to .:..:'s for the framework code shamelessly stolen from BFix :)  

var() config bool bDebug; // Log debug messages
var() config bool bEnabled; // Master breaker
var() config string LogPrefix; // String to prefix to log messages 
var() config bool bUseVerboseLogging; // Log verbosely
 
var() config bool bLogMutations; // Log successful mutations
var() config bool bLogFailures; // Log failed mutations
var() config bool bDumpConfig; // Dump configuration to log on initialization 

// Mutation specifier 
struct MutateTP  
{
 
 var() config bool bEnabled; // Slave breaker
 var() config String TeleporterName; // Name of teleporter in Level.Teleporter
                                     // instance format
 var() config String NewURL; // New destination URL 
 
};

// MutateTeleporter.Length is not recognized as a numeric value, so
// use a fixed length array until I've found out why. --zeur.

var() config array<MutateTP> MutateTeleporter[2047]; // List of mutations to
                                                     // conduct

var bool done; // Callage hack
var() config int MaxEntries; // Performance hack

//=============================================================================
// debuglog -- log a debug message.
//=============================================================================
function debuglog( coerce string themsg )
{

 if( bDebug )
 {
  Warn( themsg ); 
 }

} // function debuglog()

//=============================================================================
// PostBeginPlay -- called immediately after gameplay begins. 
//=============================================================================
event PostBeginPlay()
{

 // This is an ugly hack, but it seems to be the only way to ensure
 // callage at an appropriate time.
 SetTimer( 0.1, false );

} // event PostBeginPlay()

//=============================================================================
// Timer -- timer tick.
//=============================================================================
event Timer()
{

 // See event PostBeginPlay()
 if ( ! done )
 {

  guts();
  Done = true; 

 }

} // event timer() 

//=============================================================================
// guts -- guts of the mutator.
//=============================================================================
function guts()
{

 local int counter;
 local int maxcounter;

 if( bEnabled )
 {

  if( MaxEntries < 2048 )
  {
   maxcounter = MaxEntries + 1;
  }
  else
  {
   maxcounter = 2048;  
  }

  for( counter = 0; counter < maxcounter; counter++ ) 
  {
   ProcessConfigEntry( counter );
  }
 
 }

} // function guts()

//=============================================================================
// ProcessConfigEntry -- process a configuration entry.
//============================================================================= 
function ProcessConfigEntry( int thenum )
{

  local int theoffset;
  local byte theresult;

  LogConfig( thenum );

  if( MutateTeleporter[thenum].bEnabled )
  {

   if( ! ( MutateTeleporter[thenum].TeleporterName == "" ))
   {

    theresult = AttemptApplyMutation( MutateTeleporter[thenum].TeleporterName,
                                      MutateTeleporter[thenum].NewURL );

    if( theresult == 0 )
    {

     logmutation( "Teleporter "$MutateTeleporter[thenum].TeleporterName$
                   "successfully mutated", thenum );

     logverbose( "Success: new URL for Teleporter "$
                  MutateTeleporter[thenum].TeleporterName$" is "$
                  MutateTeleporter[thenum].NewURL );

    }
    else
    {

     if( theresult == 1 )
     {
      faillog( "Teleporter for entry #"$thenum$" not found in level!" );
     }
     else
     {
      logverbose( "Not on applicable level, entry #"$thenum$" skipped. " );
     }

    } 

   }
   else
   {

    faillog( "Entry #"$thenum$" enabled but teleporter name empty" );
    faillog( "Ignoring entry #"$thenum$"." );

   }

  }

} // function ProcessConfigEntry()

//=============================================================================
// AttemptApplyMutation -- attempt to assign a new URL to a teleporter.
//=============================================================================
function byte AttemptApplyMutation( string thename, string newURL )
{

 local string thepkg;
 thepkg = GetPackageByInstance( thename );

 debuglog( "tehname: "$thename$" :emanhet" );
 debuglog( "tehpkg: "$thepkg$" :gkphet" );
 debuglog( "tehlevelpkg: "$GetLevelPackage()$" :gkplevelhet" );

 if( thepkg == GetLevelPackage() )
 {

  debuglog( "scaahp: "$thename$" :phaacs" );
  return ApplyMutation( thename, newURL );

 }
 else
 {

  debuglog( "blaat: "$thename$" :taalb" );
  return 2;

 }

} // function byte AttemptApplyMutation()

//=============================================================================
// ApplyMutation -- assign a new URL to a teleporter. 
//=============================================================================
function byte ApplyMutation( string thename, string newURL )
{

 local Teleporter theporter;
 theporter = Teleporter( DynamicLoadObject( thename, Class'Teleporter' )); 

 if( theporter == None )
 {
  return 1;
 }
 else
 {

  theporter.URL = newURL; 
  return 0;

 }

} // function byte ApplyMutation()

//=============================================================================
// GetLevelPackage -- get the name of the current level package.
//=============================================================================
function string GetLevelPackage()
{

 local string thelevel;
 local int theoffset;

 thelevel = GetURLMap();
 theoffset = InStr( thelevel, "." );
 
 if( theoffset == -1 )
 {
  return thelevel;
 }
 else
 {
  return Left( thelevel, theoffset ); 
 }
 
} // function string GetLevelPackage()

//=============================================================================
// GetPackageByInstance -- get the name of the package containing the specified
//                         instance. 
//=============================================================================
function string GetPackageByInstance( string thestance )
{

 local int theoffset;  
 theoffset = InStr( thestance, "." );

 if( theoffset == -1 )
 {
  return "";
 } 
 else
 {
  return Left( thestance, theoffset );
 }
 
} // function string GetPackageByInstance()

//=============================================================================
// LogConfig -- Dump a cofiguration entry to the log.
//=============================================================================
function LogConfig( int thenum )
{

 local string thestring;

 if( bDumpConfig )
 {

  if( MutateTeleporter[thenum].bEnabled ) thestring = "Enabled";
  if( ! MutateTeleporter[thenum].bEnabled ) thestring = "Disabled";
  myLog( "Entry #"$thenum$" is "$thestring );

  if( MutateTeleporter[thenum].TeleporterName == "" ) thestring = "n ";
  if( ! ( MutateTeleporter[thenum].TeleporterName == "" )) thestring = " non-"; 
  myLog( "Entry #"$thenum$" has a"$thestring$"empty TeleporterName" ); 
  myLog( "Entry #"$thenum$"'s TeleporterName is "$
          MutateTeleporter[thenum].TeleporterName );


  if( MutateTeleporter[thenum].NewURL == "" ) thestring = "n ";
  if( ! ( MutateTeleporter[thenum].NewURL == "" )) thestring = " non-";
  myLog( "Entry #"$thenum$" has a"$thestring$"empty NewURL" );
  myLog( "Entry #"$thenum$"'s NewURL is "$
          MutateTeleporter[thenum].NewURL );
 
 }

} // function LogConfig; 

//=============================================================================
// myLog -- apply the correct prefix to a message and log it. 
//=============================================================================
function myLog( coerce string themsg )
{
 log( LogPrefix$themsg ); 
} // function myLog()

//=============================================================================
// logverbose -- Log a verbose message. 
//=============================================================================
function logverbose( coerce string themsg )
{

 if( bUseVerboseLogging )
 {
  myLog( themsg );    
 }
   
} // function logverbose()


//=============================================================================
// faillog -- log a failure message.
//=============================================================================
function faillog( coerce string themsg )
{

 if( bLogFailures )
 {
  myLog( "Warning: "$themsg );
 }

} // function faillog()

//=============================================================================
// logmutation -- log a message related to a successful mutation.
//=============================================================================
function logmutation( coerce string themsg, int thenum )
{

 if( bLogMutations )
 {
  myLog( "Mutation: "$themsg$" (entry #"$thenum$")" );
 }

} // function logmutation()
